<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPassengersLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfPassengersLog extends AbstractStructArrayBase
{
    /**
     * The PassengersLog
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PassengersLog[]
     */
    public $PassengersLog;
    /**
     * Constructor method for ArrayOfPassengersLog
     * @uses ArrayOfPassengersLog::setPassengersLog()
     * @param \StructType\PassengersLog[] $passengersLog
     */
    public function __construct(array $passengersLog = array())
    {
        $this
            ->setPassengersLog($passengersLog);
    }
    /**
     * Get PassengersLog value
     * @return \StructType\PassengersLog[]|null
     */
    public function getPassengersLog()
    {
        return $this->PassengersLog;
    }
    /**
     * This method is responsible for validating the values passed to the setPassengersLog method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPassengersLog method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePassengersLogForArrayConstraintsFromSetPassengersLog(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPassengersLogPassengersLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfPassengersLogPassengersLogItem instanceof \StructType\PassengersLog) {
                $invalidValues[] = is_object($arrayOfPassengersLogPassengersLogItem) ? get_class($arrayOfPassengersLogPassengersLogItem) : sprintf('%s(%s)', gettype($arrayOfPassengersLogPassengersLogItem), var_export($arrayOfPassengersLogPassengersLogItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PassengersLog property can only contain items of type \StructType\PassengersLog, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PassengersLog value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengersLog[] $passengersLog
     * @return \ArrayType\ArrayOfPassengersLog
     */
    public function setPassengersLog(array $passengersLog = array())
    {
        // validation for constraint: array
        if ('' !== ($passengersLogArrayErrorMessage = self::validatePassengersLogForArrayConstraintsFromSetPassengersLog($passengersLog))) {
            throw new \InvalidArgumentException($passengersLogArrayErrorMessage, __LINE__);
        }
        $this->PassengersLog = $passengersLog;
        return $this;
    }
    /**
     * Add item to PassengersLog value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengersLog $item
     * @return \ArrayType\ArrayOfPassengersLog
     */
    public function addToPassengersLog(\StructType\PassengersLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PassengersLog) {
            throw new \InvalidArgumentException(sprintf('The PassengersLog property can only contain items of type \StructType\PassengersLog, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PassengersLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PassengersLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PassengersLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PassengersLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PassengersLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PassengersLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PassengersLog
     */
    public function getAttributeName()
    {
        return 'PassengersLog';
    }
}
